<script setup lang="ts">
import { usePointer } from "@vueuse/core";
import { Swiper as SwiperSlider, SwiperSlide } from "swiper/vue";
import type { Swiper } from "swiper/types";
import { Navigation, A11y } from "swiper";
import "swiper/css";
import "swiper/css/navigation";
import { useGallery } from "@/stores/gallery";
import ImageTile from "@/components/ImageTile.vue";

defineProps<{
  currentIdx: number;
  width: string;
  height: string;
}>();

const emit = defineEmits<{
  (e: "update:currentIdx", newIdx: number): void;
}>();

function updateCurrentIdx(sw: Swiper) {
  emit("update:currentIdx", sw.realIndex);
}

const galleryStore = useGallery();

function handleLastSlide() {
  if (galleryStore.isFetchedAll) {
    return;
  }

  const lastImageIdShown =
    galleryStore.filteredImages[galleryStore.filteredImages.length - 1].id;
  galleryStore.getNextImages(lastImageIdShown, 10);
}

const { pointerType } = usePointer();
</script>

<template>
  <SwiperSlider
    :navigation="true"
    :a11y="true"
    :modules="[Navigation, A11y]"
    :spaceBetween="20"
    :initial-slide="currentIdx"
    :loop="true"
    :style="{
      width,
      height,
    }"
    @real-index-change="updateCurrentIdx"
    @reachEnd="handleLastSlide"
    :class="{ 'swiper-navigation-disabled': pointerType === 'touch' }"
  >
    <SwiperSlide
      v-for="image in galleryStore.filteredImages"
      :key="image.id"
      class="slide"
    >
      <ImageTile :image="image" :isSlide="true" />
    </SwiperSlide>
  </SwiperSlider>
</template>

<style lang="scss">
.swiper-button-prev {
  left: 0;
}

.swiper-button-next {
  right: 0;
}

.swiper-button-prev,
.swiper-button-next {
  top: 0;
  margin-top: 0;
  height: 100%;
  width: 10%;
  color: var(--color-primary);
  opacity: 0;
  transition: opacity var(--transition-config);

  &:hover,
  &:focus-within {
    opacity: 1;
  }
}

.swiper-button-disabled,
.swiper-button-hidden {
  visibility: hidden;
}
</style>
